package com.sun.corba.se.impl.oa.poa;

import java.util.HashSet;
import java.util.Set;
import org.omg.PortableServer.POAPackage.WrongPolicy;
import java.util.HashMap;
import java.util.Map;

class MultipleObjectMap extends ActiveObjectMap
{
    private Map entryToKeys;
    
    public MultipleObjectMap(POAImpl poaImpl) {
        super(poaImpl);
        this.entryToKeys = new HashMap();
    }
    
    @Override
    public ActiveObjectMap.Key getKey(AOMEntry aomEntry) throws WrongPolicy {
        throw new WrongPolicy();
    }
    
    @Override
    protected void putEntry(ActiveObjectMap.Key key, AOMEntry aomEntry) {
        super.putEntry(key, aomEntry);
        Set<ActiveObjectMap.Key> set = (Set)this.entryToKeys.get(aomEntry);
        if (set == null) {
            set = new HashSet();
            this.entryToKeys.put(aomEntry, set);
        }
        set.add(key);
    }
    
    @Override
    public boolean hasMultipleIDs(AOMEntry aomEntry) {
        Set<Object> set = (Set)this.entryToKeys.get(aomEntry);
        return set != null && set.size() > 1;
    }
    
    @Override
    protected void removeEntry(AOMEntry aomEntry, ActiveObjectMap.Key key) {
        Set<Object> set = (Set)this.entryToKeys.get(aomEntry);
        if (set != null) {
            set.remove(key);
            if (set.isEmpty()) {
                this.entryToKeys.remove(aomEntry);
            }
        }
    }
    
    public void clear() {
        super.clear();
        this.entryToKeys.clear();
    }
}
